/*----------------------------------------------------------------------*
 * PQueue.h
 *
 * Michael Geikowski, 22.3.93
 *
 * Definiert die Klasse PQueue zur Verwaltung von Priority Queues von
 * Knoten vom Typ 'Node' aus AdjList
 *----------------------------------------------------------------------*/

#ifndef PQUEUE_H
#define PQUEUE_H

#include "adjlistcxx.h"

class PQueue
//==========
	// Priority Queue von Knoten (Klasse Node aus AdjList). Prioritaeten
        // vom Typ float. Queuegroesse ist fix.
 {
 public:

   PQueue(int maxsize);
 //--------------------
 	// Neue Queue mit max. Groesse maxsize.

   ~PQueue();
 //----------

   void Insert(Node* n, float prio);
 //---------------------------------
 	// Knoten n mit Prioritaet prio in Queue einfuegen.

   Node* DeleteMax();
 //------------------
 	// Knoten mit groesster Prioritaet aus Queue loeschen und zurueckgeben.

   int IsEmpty()	// True, wenn Queue leer.
 //-------------
	{ return (Elems == 0 ); }

   void Empty()		// Queue leeren
 //------------
	{ Elems = 0; }

 private:
 
   class QueueElem		// Hilfsklasse fuer Queue-Eintraege
   //=============
    {
    public:

      float prio;		// Prioritaet
      Node* theNode;		// Zeiger auf Knoten
    };

   int       Elems;		// Anzahl Elemente in Queue
   int	     MaxNrOfElems;	// Max. Queuegroesse
   QueueElem *theQueue;		// Zeiger auf Array der Queue-Elemente
 };

#endif
