/*----------------------------------------------------------------------*
 * CrossRef.h
 *
 * Michael Geikowski, 7.6.93
 *
 * Definiert die Klasse CrossRef.
 *----------------------------------------------------------------------*/
 
/*----------------------------------------------------------------------*
 * Ergaenzungen : Olaf Meier, 1.9.94
 *
 * Eine zusaetzliche Memberfunktion GetParsetree() , sowie zusaetzliche Parameter
 * bei vorhandenen Routinen.
 *
 *-----------------------------------------------------------------------*/ 


#ifndef CROSSREF_H
#define CROSSREF_H

#include <assert.h>

#include "list.h"
#include "symlist.h"
// Aleitungsbaum wird zusaetzlich zwischengespeichert
#include "parsetree.h"


class CrossRef : public List
//==========================
	// Verwaltet je Modul den Modulnamen und -typ, die vom vom Scanner
        // erzeugte Symbolliste und die Liste aller explizit oder implizit
        // zu exportierender Bezeichner. Beim Loeschen eines CrossRef Objektes
        // werden alle Symbol- und Exportlisten geloescht.
 {
 public:

   CrossRef()
 //----------
	{}

   ~CrossRef()
 //-----------
	// Loescht alle Symbol- und Exportlisten.
        {}

   void Insert(char* filename, SymListElem* name, Module_Type type,
               SymList* s, SymList* export, ParseExpr* ptree, SymList* symbcopy); 
 //----------------------------------------------------------------
	// Neues Modul mit Namen `name', Typ `type', Symbolliste `s' 
        // Exportliste `export' und Parsetree 'ptree' und Symbolliste 'symbcopy' 
        // aufnehmen. Das Modul steht in Datei `filename'.

   SymList* Import(SymListElem* name, SymListElem* qual, Module_Type *mt);
 //-----------------------------------------------------------------------
	// Gibt eine Liste aller explizit oder implizit exportierten 
        // Bezeichner des Moduls mit dem Namen `name', falls qual ungleich
        // NULL versehen mit zusaetzlichem Qualifizierer qual, aus. In `mt'
        // wird der Modultyp zurueckgegeben. Die Verwendung des Modulnamen
        // wird mit den weiteren Verwendungen verknuepft.
        // Ergibt NULL, wenn `name' unbekannt.

   


   void WriteLinkFiles();
 //----------------------
 	// Erzeugt fuer jedes gespeicherte Modul eine Link-Datei.


   ParseExpr* GetParseTree(char* modname);
 //---------------------------------------
       // Liefert den Parsetree von Modul 'modname' zurueck  
 };

#endif
