CONSTANT MODULE FullTables 
(* originally from Lamports 9/91 TLA+ text, adapted to             *)
(* 2/92 and to Dortmund-Syntax: Mester, 10.7.92; Geikowski 18.5.93 *)

IMPORT  Tables;

EXPORT OPAQUE  Table, NewTable, Insert, LookUp;

PARAMETERS  InitialItem :Item;

ASSUMPTIONS
  InitialItemAssumption  ==  InitialItem :in: Item;
  
CONSTANTS
  NewTable : Table  ==  {r | r :in: Entry : r.itm = InitialItem};
  
THEOREMS
  FullTableAxioms  ==
    /\ NewTable :in: Table
    /\ :A: i :in: Item :: LookUp(i, NewTable) = InitialItem
    /\ :A: T :in: Table; n :in: Name 
           ::
              /\ LookUp(n, T) :in: Item
              /\ :A: i :in: Item :: LookUp(n, Insert(n, i, T)) = i
  ;

END
