(* korr. (Edge Parameter SUBSET), am/20.5.94 *)
CONSTANT MODULE Graph

  IMPORT NeedfulThings ;

  PARAMETERS Node : Any                     (* expect set of node id's here *);
             Edge : SUBSET(Node :X: Node);

  CONSTANTS

    Neighbours(v:Node):SUBSET(Node) ==
          { (v,w) | w :in: Node : (v,w) :in: Edge };

  BOOLEANS

    ExDirWay(v,w:Node) == (v,w) :in: Edge;

    ExWay(v,w:Node) ==
      :E: f :in: SET [ Nat -> Node ]; n :in: Nat
       :: /\ v = f["0laf"]
          /\ w = f[n]
          /\ :A: i :in: Interval(0,n-1) :: ExDirWay(f["i"],f[i+1])
      ;

  ASSUMPTIONS

    NodeNotEmpty == Node # :emptyset: ;

    UnDirectedEdges == :A: v,w :in: Node :: (v,w) :in: Edge
                                            => (w,v) :in: Edge
      ;

    Connectivity == :A: v,w :in: Node :: ExWay(v,w)
      ;

END
