CONSTANT MODULE Queue

  PARAMETERS Type : Any;

  EXPORT OPAQUE QueueType, Empty, Insert, Delete, Head, IsEmpty;

  CONSTANTS

    QueueType == [[ array : SET [ Nat -> Type ]; last : Nat ]];

    Empty : QueueType ==
      [[ array :mapsto: CHOOSE(f :in: SET [ Nat -> Type] : TRUE),
         last  :mapsto: 0
      ]];

    Insert (q:QueueType; Item:Type) : QueueType ==
      [[ array :mapsto: [ CHANGE q.array; q.last :mapsto: Item ],
         last  :mapsto: q.last+1
      ]];

    Delete (q:QueueType) : QueueType ==
      [[ array :mapsto: [ FCN n :in: Nat :mapsto: q.array[n+1] ],
         last  :mapsto: IF q.last > 0
                        THEN q.last-1
                        ELSE 0
      ]];

    Head (q:QueueType) : Type ==
      IF q.last > 0
      THEN q.arrayo["0"]
      ELSE CHOOSE (x :in: Type : TRUE)
      ;

  BOOLEANS

    IsEmpty(q:QueueType) == q.last = 0;

  ASSUMPTIONS

    TypeNotEmpty == Type # :emptyset: ;

  THEOREMS

    Axioms == :A: q :in: QueueType; i,j :in: Type
              :: /\ IsEmpty(Empty)
                 /\ ~ IsEmpty(Insert(q,i))
                 /\ Head(Insert(Empty,i)) = i
                 /\ Head(Insert(Insert(q,i,2),j)) = Head(Insert(q,i))
                 /\ Delete(Insert(Empty,i)) = Empty
                 /\ Delete(Insert(Insert(q,i),j)) =
                    Insert(Delete(Insert(q,i)),j)
    ;

END Queue
